//+------------------------------------------------------------------+
//|                          Ouverture_Fermeture_sur_ indicateur.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
extern int Magic_Number = 100;
extern int Ecart=0;
extern double TakeProfit = 1000;
extern double Lots = 0.01;
extern double TrailingStop = 0;


extern string TimeFrame       = "current time frame";
extern int    MaPeriod        = 14;
extern int    MaMethod        = MODE_LWMA;
extern int    MaPrice         = PRICE_CLOSE;
extern double AccLimit        = 0.5;
extern double AccStep         = 0.2;

string com="Ouverture_Fermeture";


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  int total,ticket,cnt;
   
 // double currSarSignalUp = iCustom(NULL,0,"Parabolic SAR of ma mtf",0,MaPeriod,MaMethod,MaPrice,AccLimit,AccStep,false,2,0);
//    double currSarSignalUp = iCustom(NULL,0,"Parabolic SAR of ma mtf","",MaPeriod,MaMethod,MaPrice,AccLimit,AccStep,false,2,1);
    double currSarSignalUp = iCustom(NULL,0,"Parabolic SAR of ma mtf","",MaPeriod,MaMethod,MaPrice,AccLimit,AccStep,false,2,1);
    double currSarSignalDn = iCustom(NULL,0,"Parabolic SAR of ma mtf","",MaPeriod,MaMethod,MaPrice,AccLimit,AccStep,false,3,1);

   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }

   
 /*    string temp = "En tete\n";
    temp = temp + "------------------------------------------------\n"    
    + "MA jour " + DoubleToStr(MaCurrent, 2) + "\n"
    + "MA veille " + DoubleToStr(MaPrevious, 2) + "\n"
    + "MACD jour" + DoubleToStr(MacdCurrent, 2) + "\n"
    + "MACD veille " + DoubleToStr(MacdPrevious, 2) + "\n"
    + "------------------------------------------------\n";
   
  */ 
   
   
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
 
      if (currSarSignalUp!=EMPTY_VALUE) // condition for buy 
     
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,com,Magic_Number,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      
     if (currSarSignalDn!=EMPTY_VALUE) // condition for sell  
      
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,com,Magic_Number,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            
           if (currSarSignalDn!=EMPTY_VALUE) // condition for sell  
     
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else 
           {
            
   
            if (currSarSignalUp!=EMPTY_VALUE) 
           
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
